class WebViewController < UIViewController
  attr_accessor :url

  def viewDidLoad
    super

    view << UIWebView.new.tap do |wv|
      wv.scalesPageToFit = true
      wv.frame = self.view.bounds
      wv.loadRequest(NSURLRequest.requestWithURL(url.nsurl))
      wv.delegate = self
    end

    @indicator = UIActivityIndicatorView.gray.tap do |iv|
      iv.center = [view.frame.size.width / 2, view.frame.size.height / 2 - 42]
    end

    view << @indicator
  end

  def webViewDidStartLoad(webview)
    @indicator.startAnimating
  end

  def webViewDidFinishLoad(webview)
    @indicator.stopAnimating
    navigationItem.title =
      webview.stringByEvaluatingJavaScriptFromString('document.title')
  end
end
